#!/bin/bash

# Default: nur Kommentarzeilen und leere Zeilen werden ausgeschlossen...
EXCLUDE="(^#|^$)"


function createjson {
    ROOM="$1"
    JSON="$2"
    SRC="$3"
    echo -n > $JSON
    GROUPMEM=$(mktemp)
    cat <<EOF >> $JSON
{
  "clients": {
EOF
    first=1;
    while read  alias mac ;  do
        # output clients, first line no "},"
	if [ $first -eq 0 ]; then
	    cat <<EOF >> $JSON
       },
EOF
	fi
	cat <<EOF >> $JSON
      "$i": {
          "alias": "$alias",
          "mac": "$mac"
EOF
	# collect members of $ROOM
	if [ $first -eq 0 ]; then
	    cat <<EOF >> $GROUPMEM
                     ,
EOF
	else
	    first=0
	fi
	cat <<EOF >> $GROUPMEM
             "$i": {}
EOF
	let i++
    done < $SRC
    cat <<EOF >> $JSON
       }
  },
  "groups": [
    {
      "name": "$ROOM",
      "members": {
EOF
    while read line; do
    cat <<EOF >> $JSON
              $line
EOF
    done < $GROUPMEM
    cat <<EOF >> $JSON
      }
  }]
}
EOF
    rm $GROUPMEM
}



# define your epoptes rooms
ROOMs="r219 r302 r202"
# define your masters (and your exceptions like printers)
MASTERs="r219-pc01 r302-pc01 r202-pc01 r219-pr01 r219-pr02 r302-pr01 r202-pr01"
for ROOM in $ROOMs; do
    echo "Extracting epoptes clients of room $ROOM assuming they belong to group $ROOM AND the hostname starts with $ROOM"
    egrep -v -e"$EXCLUDE" /etc/linuxmuster/workstations | grep "^${ROOM};${ROOM}" | awk -F\; '{print $2,$4}' > /etc/hosts.epoptes.$ROOM
    for MASTER in $MASTERs; do
	sed -i "/$MASTER/d" /etc/hosts.epoptes.$ROOM
    done

    i=0
    # create the json-file for the room
    JSON=/etc/hosts.epoptes.$ROOM.json
    createjson $ROOM $JSON /etc/hosts.epoptes.$ROOM

    mkdir -p /var/linbo/linuxmuster-client/ubuntu1604/$ROOM/home/linuxadmin/.config/epoptes/
    mv $JSON /var/linbo/linuxmuster-client/ubuntu1604/$ROOM/home/linuxadmin/.config/epoptes/groups.json


done

    